##########################################################################
#dAf
#
#y: ϐ(n)
#X: \ϐs(n*p)
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#pack="cmdsr" or "rstan" : pbP[W@cmdstanr or rstan, cmdstanrKl
#     "cmdsr"̏ꍇ 'iter' 'war'JԂ
#o
#fit:stan̏o, par:ꐔXg,  
#a:  ؕ
#b:  AWxNg(p)
#sigma: 덷W΍
#r2: W
#r:d֌W
#sb:WΉAW
#vyhat: yhat̕U
#log_lik;ΐޓx
##########################################################################
Reg <- function(y,X,see=1234, cha=5, war=1000, ite=21000, pack="cmds")
{
   library(cmdstanr)              #pbP[WcmdstanřĂяo
   library(posterior)             #pbP[WposteriořĂяo
   library(rstan)
   y<-as.vector(y); X<-as.matrix(X);
   n <- length(y);   p <- ncol(X)
   X0<-cbind(X,1);   bi<-as.vector(solve(t(X0)%*%X0)%*%t(X0)%*%y);
   sigmai<- as.vector(sqrt((sum(y^2)-t(bi)%*%t(X0)%*%y)/n));
   initi<-function(){list(bb=bi,sigma=sigmai)}
   dat <- list(n=n, p=p, y=y, X=X0)
   scr <- "stan/Reg.stan"                             # Stant@C
   par<-c("a","b","sigma","r2","r","log_lik")     # samplingϐ
   if (pack == "rstan") {
      fit<-stan(file=scr,data=dat,pars=par,
                seed=see,chains=cha,warmup=war,iter=ite,init =initi)
   }else{
      mod <- cmdstan_model(scr)                   #RpC
      csrfit <- mod$sample(data=dat,chains=cha,iter_sampling=ite,
         init =initi,iter_warmup=war,parallel_chains=cha,seed=see)    #MCMC
      fit <- rstan::read_stan_csv(csrfit$output_files())#stan`ւ̕ϊ
   }
   ext<-extract(fit,par);
   b<-ext$b
   vari<-function(xx){mean((xx-mean(xx))^2)};
   sdX<-sqrt(apply(X,2,vari))
   sb<-matrix(0,nrow(b),ncol(b))
   for (i in 1:ncol(b)){ sb[,i] <- b[,i]*sdX[i]/sqrt(vari(y));}
   out<-list(fit=fit,par=par,a=ext$a,b=ext$b,sigma=ext$sigma,r2=ext$r2,
             r=ext$r, sb=sb, X=X, y=y, log_lik=ext$log_lik);
   class(out)<-'Reg'
   return(invisible(out))
}
##########################################################################
#̃\bh
#
#x:NX 'Reg'̃IuWFNg
#degits=3 : ̊ۂ
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_,
#Xnew=F   : (n*P)̍sAPȀꍇ̓TCYñxNg@\zpf[^
#o
#waic=waicAy=yAX=X
#yhat=\lAresi=cAiXɂj
#Gc   W҉AW
#yhata yhatc@A̎㕪z@@iXnewɂj
#yasta yastc@\z@iXnewɂj
##########################################################################
print.Reg<-function(x,degits=3, prob=c(0.025, 0.05, 0.5, 0.95, 0.975),Xnew=F)
{
   Gc=NULL; yhata=NULL; yhatc=NULL; yasta=NULL; yastc=NULL;
   a<-x$a; b<-x$b; sigma<-x$sigma; r2<-x$r2; r<-x$r; sb<-x$sb; X<-x$X;
   y<-x$y; log_lik<-x$log_lik; 
   waic<- (-2)*(log(mean(exp(log_lik)))) + 2*(var(log_lik))
   print(x$fit,pars=x$par,digits_summary=degits,probs=prob)
 cat("WΉAW\n")
   Gc<-cbind(apply(sb,2,mean), apply(sb,2,sd),
      t(apply(sb,2,quantile, probs=prob)) )
      colnames(Gc)<-c("EAP","post.sd",prob)
      rownames(Gc)<-paste("b",1:ncol(b),sep="")
      print(round(Gc,degits))
#XɂyhatƎc
   yhat <- apply((b%*%t(X))+a%*%matrix(1,1,nrow(X)),2,mean);
   names(yhat)<-rownames(X)
   resi<- y-yhat;
# cat("\l\n")
#   print(round(yhat,degits))
# cat("c\n")
#   print(round(resi,degits))
 cat("ʋK\n")
   print(paste("waic=",round(waic,degits),sep=""))
#XnewɂyhatƗ\z
 if (!(is.logical(Xnew))){
    if (length(dim(Xnew))<2){Xnew<-matrix(Xnew,,1)}
 cat("A̎㕪z\n")
   yhata<-matrix(0,nrow(b),nrow(Xnew))
   yhata <- (b%*%t(Xnew))+a%*%matrix(1,1,nrow(Xnew));
   yhatc<-cbind(apply(yhata,2,mean), apply(yhata,2,sd),
      t(apply(yhata,2,quantile, probs=prob)) )
      colnames(yhatc)<-c("EAP","post.sd",prob)
      rownames(yhatc)<-rownames(Xnew)
      print(round(yhatc,degits))
 cat("ϐ̗\z\n")
   yasta<-matrix(0,nrow(b),nrow(Xnew))
   for (j in 1:nrow(Xnew))
      {yasta[,j]<-rnorm(nrow(b),yhata[,j],sigma)}
      yastc<-cbind(apply(yasta,2,mean), apply(yasta,2,sd),
      t(apply(yasta,2,quantile, probs=prob)) )
      colnames(yastc)<-c("EAP","sd",prob)
      rownames(yastc)<-rownames(Xnew)
      print(round(yastc,degits))
}
   out<-list(waic=waic,y=y,X=X,yhat=yhat,resi=resi,sb=sb, Gc=Gc,yhata=yhata,
 yhatc=yhatc, yasta= yasta,yastc=yastc)
   return(invisible(out))
}  

